package sample.sample12;

public class クッキー {
	private static int 個数;

	private String 名前;

	static {
		System.out.println("* スタティックイニシャライザが呼ばれました");
		個数 = 0;
	}

	{
		System.out.println("* インスタンスイニシャライザが呼ばれました");
		個数++;
	}

	public クッキー() {
	}

	public クッキー(String 名前) {
		this.名前 = 名前;
		System.out.print(名前 + "クッキーが作られました。");
		System.out.println("(" + 個数 + "個目)");
	}

	public static int 全体の個数() {
		return 個数;
	}

	public String toString() {
		return 名前 + "クッキーです。";
	}

	@Override
	public boolean equals(Object obj) {
		return ((クッキー) obj).名前.equals(this.名前);
	}

	@Override
	public int hashCode() {
		return 0;
	}

	@Override
	public クッキー clone() {
		return new クッキー(this.名前);
	}

	@Override
	protected void finalize() {
		クッキー.個数--;
	}
}
